
function ChannelSelectionQLearningCase1()

seed = 3;

rng(seed);

TimeHorizon=50;

% Channel 1
pbusy1=1;
pempty1=0.00000000000001;

ChS1 = ChannelStateGeneration(pbusy1,pempty1,TimeHorizon);

% Channel 2
pbusy2=0.1;
pempty2=0.2;

ChS2 = ChannelStateGeneration(pbusy2,pempty2,TimeHorizon);

figure
subplot(2,1,1); plot(ChS1);
axis([0 TimeHorizon -0.5 1.5]);
xlabel('time');
ylabel('Channel 1');

subplot(2,1,2); plot(ChS2);
axis([0 TimeHorizon -0.5 1.5]);
xlabel('time');
ylabel('Channel 2');

% ----- Q-learning -----

% States = {Ch1E,Ch1B,Ch1E,Ch1B}={1,2,3,4}
% Actions = {Stay,Change}={1,2};

% We also need to explore to learn
Epsilon = 0.1;
Delta = 0;
%Epsilon = 1;
%Delta = 0.01;

Q_table = zeros(4,2); % The Q-table

state = zeros(1,TimeHorizon);
action = zeros(1,TimeHorizon);
reward = zeros(1,TimeHorizon);
channel = zeros(1,TimeHorizon);
explore = zeros(1,TimeHorizon);

K=2; % Number of actions

action_ntimes = zeros(4,2); % Times I selected one action

state(1)=1+ChS1(1); % The agent starts in state 1
channel(1)=1;

alfa = 0.2; % learning rate
gamma = 0.9; % discount factor

% Rewards 
Reward_Good = 1;
Reward_Bad = -1;
AcReward = 0;


disp('I have no info at the start');
disp(Q_table);

for t=1:TimeHorizon-1

     disp('Iteration | Current State');
     disp([t state(t)]);
    
     if rand < Epsilon 
       p = randi(K); % I explore an action randomly
       explore(t)=1;
    else
       [~,p]=max(Q_table(state(t),:)); % I take the best action from the state in which I'm 
    end
    
    action(t)=p;
    action_ntimes(state(t),action(t))=action_ntimes(state(t),action(t)) + 1;
        
    disp('Explore? | Action (1 = stay | 2 = switch)');
    disp([explore(t) action(t)]);
    
    % Next State
    
    if(state(t)==1)
       if(action(t)==1) % stay
           state(t+1) = 1 + ChS1(t+1);
           channel(t+1)=1;
       else
           state(t+1) = 3 + ChS2(t+1);
           channel(t+1)=2;
       end
    end
    
    if(state(t)==2)
       if(action(t)==1) % stay
           state(t+1) = 1 + ChS1(t+1);
           channel(t+1)=1;
       else
           state(t+1) = 3 + ChS2(t+1);
           channel(t+1)=2;
       end
    end

    if(state(t)==3)
       if(action(t)==1) % stay
           state(t+1) = 3 + ChS2(t+1);
           channel(t+1)=2;
       else
           state(t+1) = 1 + ChS1(t+1);
           channel(t+1)=1;
       end
    end
    
    if(state(t)==4)
       if(action(t)==1) % stay
           state(t+1) = 3 + ChS2(t+1);
           channel(t+1)=2;
       else
           state(t+1) = 1 + ChS1(t+1);
           channel(t+1)=1;
       end
    end
        
    % Reward 

    switch state(t+1)
        case 1
            reward(t)=Reward_Good;
        case 2 
            reward(t)=Reward_Bad;
        case 3 
            reward(t)=Reward_Good;
        case 4 
            reward(t)=Reward_Bad;
    end
    
    disp('Next state | Reward (1 = well done | -1 = :( )');
    disp([state(t+1) reward(t)]);
   
    
    AcReward = AcReward + reward(t);
    
    % Update Q-Table
    
   
    disp('(1-alfa) * Q_table(state(t),action(t)) + alfa * ( reward(t) + gamma * max(Q_table(state(t+1),:))) = ');
    disp([(1-alfa) Q_table(state(t),action(t))  alfa reward(t) gamma max(Q_table(state(t+1),:)) ]);
    
    Q_table(state(t),action(t))=(1-alfa)*Q_table(state(t),action(t)) + alfa*(reward(t) + gamma*max(Q_table(state(t+1),:)));
    
    
    %disp('t state(t) action(t) reward(t) channel(t+1) state(t+1) Q_table(state(t),action(t)');
    %disp([t state(t) action(t) reward(t) channel(t+1) state(t+1) Q_table(state(t),action(t))]);

    disp('-----Q-table-----');
    disp(Q_table);
    disp('-----------------');
    
    pause
    
    Epsilon = Epsilon - Delta;
      
end

disp('Q table');
disp(Q_table);

disp('Accumulated Reward');
disp(AcReward);

figure
subplot(3,1,1); plot(ChS1,'k');
axis([0 TimeHorizon -0.5 1.5]);
xlabel('time');
ylabel('Channel 1');

subplot(3,1,2); plot(ChS2);
axis([0 TimeHorizon -0.5 1.5]);
xlabel('time');
ylabel('Channel 2');

subplot(3,1,3); plot(channel,'ro');
axis([0 TimeHorizon 0.5 2.5]);
xlabel('time');
ylabel('Selected Channel');

end

function [ChS]=ChannelStateGeneration(pbusy,pempty,TimeHorizon)

ChS=zeros(1,TimeHorizon);

ChS(1)=round(rand);

for t=2:TimeHorizon
    if(ChS(t-1)==1) % State Busy
        if(rand < pempty)
           ChS(t)=0; 
        else
           ChS(t)=1; 
        end
    else % State Empty
        if(rand < pbusy)
           ChS(t)=1; 
        else
           ChS(t)=0; 
        end
    end
end

end